<template>
  <div id="form">
    <form @submit.prevent="postName">
      <label>Entrez votre nom de personnage :</label>
      <span>4 caractères minimum - 24 caractères maximum.</span>
      <input :disabled="!isValid" type="text" v-model="name" maxlength="24" minlength="4" placeholder="Mon super nom">
      <button :disabled="!isValid" type="submit" class="btn">C'est parti !</button>
    </form>
    <p class="loading" v-if="!isValid">Chargement en cours des données...</p>
  </div>
</template>

<script>
export default {
  name: "Form",
  data: function() {
    return {
      name: "",
      isValid: true
    };
  },
  methods: {
    postName: function() {
      if(this.name !== '' && this.isValid) {
        this.isValid = false;
        this.$emit('enterName', this.name);
      }
    }
  }
}
</script>

<style scoped>

form {
  display: flex;
  flex-direction: column;
}

span {
  font-size: 12px;
  font-style: italic;
  margin-bottom: 4px;
}

input {
  margin: 12px 0;
  padding: 6px 12px;
}

.btn {
  max-width: unset;
}

.loading {
  margin-top: 32px;
  text-align: center;
  transition: all ease-in-out 1s;
}

</style>